#line 1 "C:/Users/raj/Desktop/EmbeddedLab_Code/MikroC_PIC/PIC16F1827/MatrixKeypad2/MatrixKeypad2.c"


sbit Col1 at RB4_bit;
sbit Col2 at RB5_bit;
sbit Col3 at RB6_bit;
sbit Col4 at RB7_bit;


sbit LCD_RS at RA6_bit;
sbit LCD_EN at RA7_bit;
sbit LCD_D4 at RA0_bit;
sbit LCD_D5 at RA1_bit;
sbit LCD_D6 at RA2_bit;
sbit LCD_D7 at RA3_bit;
sbit LCD_RS_Direction at TRISA6_bit;
sbit LCD_EN_Direction at TRISA7_bit;
sbit LCD_D4_Direction at TRISA0_bit;
sbit LCD_D5_Direction at TRISA1_bit;
sbit LCD_D6_Direction at TRISA2_bit;
sbit LCD_D7_Direction at TRISA3_bit;



char message1[] = "Hit Key:";
char KeyPad[] = " ";
unsigned short temp1, temp2;
unsigned short col, row;

char KeyS[4][4] ={
 {0x31, 0x32, 0x33, 0x41},
 {0x34, 0x35, 0x36, 0x42},
 {0x37, 0x38, 0x39, 0x43},
 {0x2A, 0x30, 0x23, 0x44}
 };
void Debounce(){
 Delay_ms(50);
}

char Get_Key(){

 TRISB = 0b11110000;
 WPUB = 0b11110000;
 PORTB = 0b11110000;
 temp1 = (PORTB >> 4) ^ 0x0F;
 col = temp1/2;
 if(col == 4) col = 3;

 TRISB = 0b00001111;
 WPUB = 0b00001111;
 PORTB = 0b00001111;
 temp2 = PORTB ^ 0x0F;
 row = temp2/2;
 if (row == 4) row = 3;
 if (temp1 && temp2) return KeyS[row][col];
 return ' ';

}

void main() {
 char key[] = " ";
 TRISA = 0b00100000;
 TRISB = 0b00000000;
 ANSELA = 0x00;
 ANSELB = 0x00;
 OPTION_REG = 0x00;
 PORTB = 0b11111111;
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,1,message1);

 do {
 key[0] = Get_Key();
 if (key[0] != ' ') Lcd_Out(2,7,key);
 }while(1);
}
