
_Debounce:

;MatrixKeypad2.c,35 :: 		void Debounce(){
;MatrixKeypad2.c,36 :: 		Delay_ms(50);
	MOVLW      9
	MOVWF      R12
	MOVLW      28
	MOVWF      R13
L_Debounce0:
	DECFSZ     R13, 1
	GOTO       L_Debounce0
	DECFSZ     R12, 1
	GOTO       L_Debounce0
	NOP
;MatrixKeypad2.c,37 :: 		}
L_end_Debounce:
	RETURN
; end of _Debounce

_Get_Key:

;MatrixKeypad2.c,39 :: 		char Get_Key(){
;MatrixKeypad2.c,41 :: 		TRISB = 0b11110000;
	MOVLW      240
	MOVWF      TRISB+0
;MatrixKeypad2.c,42 :: 		WPUB  = 0b11110000;
	MOVLW      240
	MOVWF      WPUB+0
;MatrixKeypad2.c,43 :: 		PORTB = 0b11110000;
	MOVLW      240
	MOVWF      PORTB+0
;MatrixKeypad2.c,44 :: 		temp1  = (PORTB >> 4) ^ 0x0F;
	MOVF       PORTB+0, 0
	MOVWF      R0
	LSRF       R0, 1
	LSRF       R0, 1
	LSRF       R0, 1
	LSRF       R0, 1
	MOVLW      15
	XORWF      R0, 0
	MOVWF      R2
	MOVF       R2, 0
	MOVWF      _temp1+0
;MatrixKeypad2.c,45 :: 		col   = temp1/2;
	MOVF       R2, 0
	MOVWF      R1
	LSRF       R1, 1
	MOVF       R1, 0
	MOVWF      _col+0
;MatrixKeypad2.c,46 :: 		if(col == 4) col = 3;
	MOVF       R1, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L_Get_Key1
	MOVLW      3
	MOVWF      _col+0
L_Get_Key1:
;MatrixKeypad2.c,48 :: 		TRISB = 0b00001111;
	MOVLW      15
	MOVWF      TRISB+0
;MatrixKeypad2.c,49 :: 		WPUB  = 0b00001111;
	MOVLW      15
	MOVWF      WPUB+0
;MatrixKeypad2.c,50 :: 		PORTB = 0b00001111;
	MOVLW      15
	MOVWF      PORTB+0
;MatrixKeypad2.c,51 :: 		temp2  = PORTB ^ 0x0F;
	MOVLW      15
	XORWF      PORTB+0, 0
	MOVWF      R2
	MOVF       R2, 0
	MOVWF      _temp2+0
;MatrixKeypad2.c,52 :: 		row   = temp2/2;
	MOVF       R2, 0
	MOVWF      R1
	LSRF       R1, 1
	MOVF       R1, 0
	MOVWF      _row+0
;MatrixKeypad2.c,53 :: 		if (row == 4) row = 3;
	MOVF       R1, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L_Get_Key2
	MOVLW      3
	MOVWF      _row+0
L_Get_Key2:
;MatrixKeypad2.c,54 :: 		if (temp1 && temp2)  return KeyS[row][col];
	MOVF       _temp1+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_Get_Key5
	MOVF       _temp2+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_Get_Key5
L__Get_Key10:
	MOVF       _row+0, 0
	MOVWF      R0
	CLRF       R1
	LSLF       R0, 1
	RLF        R1, 1
	LSLF       R0, 1
	RLF        R1, 1
	MOVLW      _KeyS+0
	ADDWF      R0, 1
	MOVLW      hi_addr(_KeyS+0)
	ADDWFC     R1, 1
	MOVF       _col+0, 0
	ADDWF      R0, 0
	MOVWF      FSR0L
	MOVLW      0
	ADDWFC     R1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	MOVWF      R0
	GOTO       L_end_Get_Key
L_Get_Key5:
;MatrixKeypad2.c,55 :: 		return ' ';
	MOVLW      32
	MOVWF      R0
;MatrixKeypad2.c,57 :: 		}
L_end_Get_Key:
	RETURN
; end of _Get_Key

_main:

;MatrixKeypad2.c,59 :: 		void main() {
;MatrixKeypad2.c,60 :: 		char key[] = " ";
	MOVLW      32
	MOVWF      main_key_L0+0
	CLRF       main_key_L0+1
;MatrixKeypad2.c,61 :: 		TRISA  = 0b00100000;   // PORTA output except RA5
	MOVLW      32
	MOVWF      TRISA+0
;MatrixKeypad2.c,62 :: 		TRISB  = 0b00000000;
	CLRF       TRISB+0
;MatrixKeypad2.c,63 :: 		ANSELA = 0x00;         // Disable any analog functions in PORTA
	CLRF       ANSELA+0
;MatrixKeypad2.c,64 :: 		ANSELB = 0x00;         // Disable any analog functions in PORTB
	CLRF       ANSELB+0
;MatrixKeypad2.c,65 :: 		OPTION_REG = 0x00;
	CLRF       OPTION_REG+0
;MatrixKeypad2.c,66 :: 		PORTB  = 0b11111111;   // All rows equal to 1
	MOVLW      255
	MOVWF      PORTB+0
;MatrixKeypad2.c,67 :: 		Lcd_Init();
	CALL       _Lcd_Init+0
;MatrixKeypad2.c,68 :: 		Lcd_Cmd(_LCD_CLEAR);             // CLEAR display
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;MatrixKeypad2.c,69 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);        // Cursor off
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;MatrixKeypad2.c,70 :: 		Lcd_Out(1,1,message1);           // Write message1 in 1st row
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _message1+0
	MOVWF      FARG_Lcd_Out_text+0
	MOVLW      hi_addr(_message1+0)
	MOVWF      FARG_Lcd_Out_text+1
	CALL       _Lcd_Out+0
;MatrixKeypad2.c,72 :: 		do {
L_main6:
;MatrixKeypad2.c,73 :: 		key[0] = Get_Key();
	CALL       _Get_Key+0
	MOVF       R0, 0
	MOVWF      main_key_L0+0
;MatrixKeypad2.c,74 :: 		if (key[0] != ' ') Lcd_Out(2,7,key);
	MOVF       R0, 0
	XORLW      32
	BTFSC      STATUS+0, 2
	GOTO       L_main9
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      7
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      main_key_L0+0
	MOVWF      FARG_Lcd_Out_text+0
	MOVLW      hi_addr(main_key_L0+0)
	MOVWF      FARG_Lcd_Out_text+1
	CALL       _Lcd_Out+0
L_main9:
;MatrixKeypad2.c,75 :: 		}while(1);
	GOTO       L_main6
;MatrixKeypad2.c,76 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
